function [map,ncols] = glitchCut(params,map)
% function map = glitchCut(params,map)

% All glitch routines return an array that correspond to the columns of the ft-map to cut

% Most of these cuts are for diagnostic purposes and are not appropriate for
% analysis purposes.  The vetted cuts are 5 and 11.  If any other cut is 
% requested by the user, a warning message is generated by paramCheck.
if (params.glitchCut==1) % Shivaraj, negative SNR.
  cut_map = map.snr <= -2;
  cut_col = (sum(cut_map)/length(cut_map(:,1))) > 0.07;
elseif (params.glitchCut==2) % Michael, absolute SNR.
  cut_map = abs(map.snr) > 2;
  cut_col = (sum(cut_map)/length(cut_map(:,1))) > 0.20;
elseif (params.glitchCut==3) % Tanner, negative SNR.
  cut_map = map.snr < -6;
  cut_col = (sum(cut_map)/length(cut_map(:,1))) > 0.00832;
elseif (params.glitchCut==4) % Tanner, negative SNR.
  cut_map = map.snr < -4;
  cut_col = (sum(cut_map)/length(cut_map(:,1))) > 0.01;
%------------------------------------------------------------------------------
% Tanner, Xi.  (The "standard" Xi cut.)
% For additional documentation see
% https://dcc.ligo.org/cgi-bin/private/DocDB/ShowDocument?docid=71680
elseif (params.glitchCut==5)
  cut_col = Xi_cut(map,params);
%------------------------------------------------------------------------------
elseif (params.glitchCut==6) % Tanner, Xi + negative SNR.
  cut_col_Xi = Xi_cut(map,params);
  cut_map_neg = map.snr < -4;
  cut_col_neg = (sum(cut_map_neg)/length(cut_map_neg(:,1))) > 0.01;
  cut_col = (cut_col_Xi | cut_col_neg);
elseif (params.glitchCut==7) % Michael, DQ_cut
  cut_col_DQ = DQ_cut(map,params);
  % Check that the number of segments are consistent
  cut_col_num_of_segments = zeros(size(map.xvals));
  cut_col = (cut_col_DQ | cut_col_num_of_segments);
%------------------------------------------------------------------------------
% Michael, DQ cut + Xi
% This cut applies the Xi cut (see #5 above) as well as DQ flags.
elseif (params.glitchCut==8)
  cut_col_Xi = Xi_cut(map,params);
  cut_col_DQ = DQ_cut(map,params);
  cut_col = (cut_col_Xi | cut_col_DQ);
%----------------------------------------------------------------------------  
else
  warning('params.glitchCut must be 1-8.  No cut applied!');
  cut_col = [];
end

ncols=sum(cut_col>0);

% Cut the vetoed columns by assigning values of NaN.
%eht: 
%map.snr(:,cut_col) = 0;
%map.y(:,cut_col) = 0;
%map.F(:,cut_col) = 0;
%map.sigma(:,cut_col) = 1;
%map.sigF(:,cut_col) = 1e99;

map.snr(:,cut_col) = NaN;
map.y(:,cut_col) = NaN;
map.F(:,cut_col) = NaN;
map.sigma(:,cut_col) = NaN;
map.sigF(:,cut_col) = NaN;

% Record cut columns

if params.recordCuts
  if sum(cut_col) > 0
    if ~(exist('glitchCuts'))
      warning(['directory ./glitchCuts does not exist.  Any cuts made will' ...
  'not be recorded.'])
      return
    end
  fid = fopen(['glitchCuts/cuts' num2str(params.startGPS) '.txt'],'w+');
    for i = 1:length(cut_col);
      if cut_col(i) == 1
        cutGPS = map.segstarttime(i);
        fprintf(fid, [num2str(cutGPS) '\n']);
      end
    end
    fclose(fid);
  end
end


return
